(* An binary search tree contains nodes that have up to two children.
   Children to the left are less than the parent.
   Children to the right are greater than the parent
*)

(* we represent the tree using empty Leaf nodes,
   or a value and two sub-trees: left and right
*)
type bst = 
  | Leaf
  | Node of int * bst * bst

(** does the tree contain a given element? *)
let rec contains (b:bst) (x:int) = 
    match b with 
        Leaf -> false
       | Node (v,left,right) -> 
          if x = v then
            true
          else if x < v then
            contains left x
          else contains right x

(** insert a new element into a tree and return a new tree *)
let rec insert (b:bst) (x:int) =
    match b with
      Leaf -> Node(x, Leaf, Leaf)
    | Node(y, left, right) ->
        if x <= y then
           Node(y, insert left x, right)
        else
           Node(y, left, insert right x)

